package com.loafle.overflow.module.history.service;

import com.loafle.overflow.module.history.dao.HistoryDAO;
import com.loafle.overflow.module.history.model.History;
import com.loafle.overflow.module.meta.model.MetaHistoryType;
import com.loafle.overflow.module.probe.model.Probe;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

@Service("HistoryService")
public class HistoryService {

    @Autowired
    private HistoryDAO historyDAO;

    public History regist(History history) {
        return this.historyDAO.save(history);
    }

//    public List<History> readAllByProbe(Probe probe) {
//        return this.historyDAO.findAllByProbeOrderByIdDesc(probe);
//    }

    public Page<History> readAllByProbeAndType(Probe probe, MetaHistoryType type, int pageNo, int countPerPage) {
        Pageable pageRequest =
                new PageRequest(pageNo, countPerPage, new Sort(Sort.Direction.DESC, "id"));
        return this.historyDAO.findAllByProbeAndType(probe, type, pageRequest);
    }

    public Page<History> readAllByProbe(Probe probe, int pageNo, int countPerPage) {
        Pageable pageRequest =
                new PageRequest(pageNo, countPerPage, new Sort(Sort.Direction.DESC, "id"));
        return this.historyDAO.findAllByProbe(probe, pageRequest);
    }
}
