package com.loafle.overflow.module.infra.service;

import com.loafle.overflow.module.domain.model.Domain;
import com.loafle.overflow.module.infra.dao.InfraDAO;
import com.loafle.overflow.module.infra.model.Infra;
import com.loafle.overflow.module.probe.model.Probe;
import com.loafle.overflow.module.probe.service.ProbeService;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */

@Service("InfraService")
public class InfraService {

    @Autowired
    InfraDAO infraDAO;

    @Autowired
    private ProbeService probeService;

    public Infra regist(Infra infra) {
        return this.infraDAO.save(infra);
    }

    public Infra read(long id) {
        return this.infraDAO.findOne(id);
    }

    public Page<Infra> readAllByProbe(Probe probe, int pageNo, int countPerPage) {
        Pageable pageRequest =
                new PageRequest(pageNo, countPerPage, new Sort(Sort.Direction.DESC, "id"));
        return this.infraDAO.findAllByProbe(probe, pageRequest);
    }

    public Page<Infra> readAllByDomain(Domain domain, int pageNo, int countPerPage) {

        List<Probe> probeList = this.probeService.readAllByDomain(domain);

        Pageable pageRequest =
                new PageRequest(pageNo, countPerPage, new Sort(Sort.Direction.DESC, "id"));

        return this.infraDAO.findAllByProbeList(probeList, pageRequest);
    }

//    public List<Infra> readAllByProbeList(List<Probe> probeList) {
//        return this.infraDAO.findAllByProbeList(probeList);
//    }

    public List<Target> readAllTargetByDomain(Domain domain) {

        List<Probe> probeList = this.probeService.readAllByDomain(domain);

        return this.infraDAO.findAllTargetByProbeList(probeList);
    }

    public List<Target> readAllTargetByProbeList(List<Probe> probeList) {
        return this.infraDAO.findAllTargetByProbeList(probeList);
//        return null;
    }


}
